<?php

	include_once("authorize.php");	
  checkUser();   
	
	$ad_pattern = "/google_ad_client/";
	$an1_pattern = "/gaJsHost/";
	$an2_pattern = "/_uacct/";
	$code_pattern = "/google_ad_client(.)*=(.)*\"(.)*\"/i";

  $days = preg_replace("/[^0-9]/i",'', $_POST["days"]); 
  $path = preg_replace("/[^_A-Za-z0-9-\.%\/]/i",'', $_POST["path"]);   
  $path = preg_replace("/\.\.\//",'', $path); 	
  $dispday = $days;
  if(intval($dispdays) == 0) $dispdays=7;
  $pageonly = $_POST["pageonly"];
  $thispage = __FILE__;
  
  include_once("ini.php");
  readIni();
  function isPage($url)
  {
    $ext = strrchr($url, ".");
    return isValid($ext);
  }   
  
?>	
<html>
<head>
<link type="text/css" href="script.css" rel="stylesheet">
<meta name="robots" content="none">
<script type="text/javascript">
function nolimit()
{
  var state = document.analytics.cb.checked;
  if(state)
  {
    document.analytics.days.value = "9999";
  }
}
</script>
</head>
<body>
<div id="content">
<h2>Analytics Check</h2>
<br>
<form method="post" name="analytics">
  Within : <input type="text" name="days" id="days" maxlength="4" size="4" value="<?php echo $dispdays; ?>"> days
  <span style="margin-left:16px">No limit:</span>
  <input type="checkbox" name="cb" id="cb" onclick="nolimit()" >
  <span style="margin-left:16px">Pages only:</span>
  <input type="checkbox" name="pageonly" id="pageonly" checked
  onchange="element.value=element.checked" >
  <span style="margin-left:16px">Starting directory:</span> 
  <input type="text" name="path" maxlength="80" size="30" value="/" > 
  <input type="submit" value="Start Check" >
</form>

<br>
    
<?php    

    $dispflag = 0;                        
    $i = 0;                              
    $dir_count = 0;                      
    $date = time();                      
    $one_day = 86400;
    define('ABSPATH', $_SERVER['DOCUMENT_ROOT']);
    $path = ABSPATH.$path;   
    $dirlist[$dir_count] = $path;
    $rootlen = strlen(ABSPATH);
    $codelist = array();
    
    function check($filename)
    {
      global $codectr;
      global $ad_pattern;
      global $an1_pattern;
      global $an2_pattern;
      global $code_pattern;      
      global $codelist;
      global $thispage;
	
	    if($filename == $thispage) return;
	
      $content = file_get_contents($filename);
      $codectr = 0;
      $ad = preg_match($ad_pattern, $content); 
      if($ad > 0)
      { 
        $codectr +=1;
        preg_match_all($code_pattern, $content, $matches);
        $x = $matches[0];
        foreach($x as $codeline)
        {
          $pos = strpos($codeline, "\"") + 1;
          $code = substr($codeline, $pos, strlen($codeline)- $pos - 1);
          if(!in_array($code, $codelist))
            array_push($codelist, $code);
        }
      }  
      $an1 = preg_match($an1_pattern, $content);
      if($an1 > 0) $codectr += 2;
      else
      {
        $an = preg_match($an2_pattern, $content);
        if($an2 > 0) $codectr += 2;
      }
      $color = "#999999";
      switch($codectr)
      {
        case 1: $color = "#990000"; break;
        case 2: $color = "#009900"; break;
        case 3: $color = "#990099";                
      }
      return $color;
    }
    
    $dispflag = $one_day * $days;
    if($dispflag > 0)
    {
        $fcounter = 0;    
        print "<br><table><tr><td width=\"450\"><b><u>Filename</u></b></td><td><b><u>Last modified date</u></b></td></tr>";
        $diff = $date - $dispflag;
        
        while($i <= $dir_count)
        {
            $currdir = $dirlist[$i];
            $dircontent = opendir( $dirlist[$i] );
            while($fname = readdir( $dircontent))
            {
                if($fname == '.') continue;
                if($fname == '..') continue;

                $fullpath = $currdir . $fname;
                if(is_dir($fullpath))
                {
                        $dir_count++;
                        $dirlist[$dir_count] = $fullpath . "/";
                }
                else
                {
                        if($pageonly && !isPage($fname)) continue;
                        $file_date = filemtime($fullpath);                             
                        if ($file_date > $diff)
                        {
                            $relname = substr($fullpath, $rootlen);
                            $color = check($fullpath);
                            print "<tr><td><font color=\"$color\">".$relname. "</font></td>";
                            print "<td><font color=\"$color\">". date("M d, Y  -  H:i:s", $file_date)."</font></td></tr>";
                            $fcounter ++;
                        }
                }
            }
            closedir ( $dircontent );
            $i++;    
        }
        print "</table>";   
        print "<br />Within <strong>" . ($dispflag/$one_day) ."</strong> days, <strong>$fcounter</strong> files changed.<br>"; 
        if(count($codelist) > 0)
        {
          print "<u>Adsense codes</u>:";
          foreach($codelist as $code) { print " <b>".$code."</b>"; }
          print "<br>";
        }  
    }

      
?>


</div>
</body>
</html> 
