<?php
include_once("authorize.php");	
checkUser();  
?>

<html>
<head></head>
<body>

<?php

/*
     Bioloide Gallery Generator
     (c)2099-2011 Scriptol.com
     Licence GPL 3.0
    
    Input:
    - List of files
    - Name of the zip file
    - Path of the archive to create
    - HTTP URL
    
*/

$ziplist = array();
$title = "";
$path = "";
$fhandle = false;

function generate()
{
    global $localfile;
    global $ziplist;
    global $quiet;
    global $zipname;
    
    $zip = new ZipArchive;
    
    if($zip->open($localfile, ZipArchive::CREATE) === true)
    {
        foreach($ziplist as $file)
        {
          $path = ABSPATH.$file;
          if($zip->addFile($path, $file))
          {
            if(!$quiet)
              print "$file added.<br>\n";
          }  
          else
            print "Error, $file not added.<br>\n" ;
        }  

        $zip->close();
        print "Done.<br>\n";
        return true;
    }

    print "Enable to create $zipname or Zip not supported.<br>\n";
    return false;   
}    
    

define('ABSPATH', $_SERVER['DOCUMENT_ROOT']);    
$typed = preg_replace("/[^_A-Za-z0-9-\.%\/]/i",'', $_POST["path"]);
$target = ABSPATH.preg_replace("/\.\.\//",'', $typed);
$protocol = $_SERVER['SERVER_PROTOCOL'];
$protocol = preg_split("/[^a-z|A-Z]/i", $protocol);
$protocol=strtolower($protocol[0]);
$domain = $_SERVER['HTTP_HOST'];
$root = $protocol."://".$domain;
$rootlen = strlen(ABSPATH);

$quiet = $_POST['quiet'];
$zipname=$_POST['zipname'];

if($zipname == false || $zipname == ".zip")
{
  $zipname = $domain.".zip";
}

$url = $root."/".$zipname;
$localfile=ABSPATH."/".$zipname;

foreach($_POST as $key => $value)
{
   if(strlen($key) < 3) continue;
   if(substr($key, 0, 2) != "cb") continue;
   array_push($ziplist, $value);  
}

if(file_exists($localfile)) 
    @unlink($localfile);

if(generate())   
{
  print "<p><a href='$url'><b>$zipname</b></a> generated. </p>";
  print "<p>Location: $url </p>";
}  
else
  print "<p>Something wrong...</p>";

?>

</body>
</html>
